Package ghidra.app.plugin.processors.sleigh

# Enum Class UniqueLayout

java.lang.Object
java.lang.Enum<UniqueLayout>
ghidra.app.plugin.processors.sleigh.UniqueLayout

All Implemented Interfaces:
  `Serializable`, `Comparable<UniqueLayout>`, `Constable`

public enum UniqueLayout extends Enum<UniqueLayout>
Offsets for various ranges in the p-code unique space. Offsets are either: 1) Relative to the last temporary allocated statically by the SLEIGH compiler or a particular language (.sla), OR 2) Absolute within the unique address space. So the layout of the unique address space looks like: 1) SLEIGH static temporaries 2) Runtime temporaries used by the SLEIGH p-code generator 3) Temporaries used by the PcodeInjectLibrary for p-code snippets 4) Temporaries generated during (decompiler) analysis The "unique" space is set to 32 bits across all architectures. The maximum offset is 0xFFFFFFFF. The offsets and names should match with the parallel decompiler enum in translate.hh

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `ANALYSIS`
  `INJECT`
  `RUNTIME_BITRANGE_EA`
  `RUNTIME_BOOLEAN_INVERT`
  `RUNTIME_RETURN_LOCATION`
  `SLEIGH_BASE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `long`
  `getOffset(SleighLanguage language)`
  Get the starting offset of a named range in the unique address space.
  `static UniqueLayout`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static UniqueLayout[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### SLEIGH_BASE

    public static final UniqueLayout SLEIGH_BASE

  - ### RUNTIME_BOOLEAN_INVERT

    public static final UniqueLayout RUNTIME_BOOLEAN_INVERT

  - ### RUNTIME_RETURN_LOCATION

    public static final UniqueLayout RUNTIME_RETURN_LOCATION

  - ### RUNTIME_BITRANGE_EA

    public static final UniqueLayout RUNTIME_BITRANGE_EA

  - ### INJECT

    public static final UniqueLayout INJECT

  - ### ANALYSIS

    public static final UniqueLayout ANALYSIS

- ## Method Details

  - ### values

    public static UniqueLayout[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static UniqueLayout valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getOffset

    public long getOffset(SleighLanguage language)
    Get the starting offset of a named range in the unique address space. The returned offset is absolute and specific to the given SLEIGH language.
    Parameters:
      `language` - is the given SLEIGH language
    Returns:
      the absolute offset